import asyncio

from cpl_core.application import ApplicationBuilder, ApplicationABC

from gismo.application import Application
from gismo.startup import Startup
from modules.boot_log.boot_log_extension import BootLogExtension


async def main():
    app_builder = ApplicationBuilder(Application)
    app_builder.use_extension(BootLogExtension)
    app_builder.use_startup(Startup)
    app: ApplicationABC = await app_builder.build_async()
    await app.run_async()


if __name__ == '__main__':
    ml = asyncio.get_event_loop()
    ml.run_until_complete(main())
